#include "decor.h"

Plugin::~Plugin() {
  // something here eh
}

void Plugin::entry(dev *devo) {
  d=devo;
  disp=d->getdisp();

  LoadConfig();
}

void Plugin::LoadConfig() {
ifstream fstr;
string filename, data;
int x, y, w, h;

  filename.assign(getenv("HOME"));
  filename.append("/.devolution/devo_conf");
  fstr.open(filename.c_str(), ios::in);

  while(fstr) {
    fstr >> data;
    if(data=="ShowDecor") {
      fstr >> data >> x >> y >> w >> h;
      CreateWindow(x,y,w,h);
      image=Imlib_load_image(d->dat, (char*)data.c_str());
      Imlib_apply_image(d->dat, image, win);
    }
  } fstr.close();  
}

void Plugin::CreateWindow(int x, int y, int w, int h) {
XSetWindowAttributes xswa;

  xswa.override_redirect=True;
  xswa.event_mask=SubstructureRedirectMask|SubstructureNotifyMask;
  win=XCreateWindow(disp, *d->getroot(), x, y, w, h, 0, CopyFromParent, InputOutput, CopyFromParent, CWOverrideRedirect|CWEventMask, &xswa);
  XMapRaised(disp, win);
}

