#include "events.h"

events::events(dev *devo) {
  d=devo;
  disp=d->getdisp();

  active=None;
  callback=None;
  tim=None;
}

void events::scan() {
Window dummy, *subs;
unsigned int isubs, i;
XWindowAttributes xwa;

  XQueryTree(disp, *d->getroot(), &dummy, &dummy, &subs, &isubs);
  for(i=0; i<isubs; i++) {
    XGetWindowAttributes(disp, subs[i], &xwa);
    if(xwa.map_state==IsViewable && xwa.override_redirect==False) {
      frame *blah;
      blah=new frame(d, subs[i], FRAME_NORMAL);
    }
  }

}

void events::loop() {
XEvent ev;
  scan();

  for(;;) {
   if(XPending(disp)) {
      XNextEvent(disp, &ev);
      for(cb_wrapper *cbw=callback; cbw; cbw=cbw->next) cbw->callback->cb_xevent(&ev);
      switch(ev.type) {

         case EnterNotify:
           enter(&ev.xcrossing); break;
         case ButtonPress: case ButtonRelease: case MotionNotify:
           button(&ev); break;
         case KeyPress:
           key(&ev.xkey); break;
         case MapRequest:
           map(&ev.xmaprequest); break;
         case UnmapNotify:
           unmap(&ev.xunmap); break;
         case DestroyNotify:
           destroy(&ev.xdestroywindow); break;
         case Expose:
           expose(&ev.xexpose); break;
         case ConfigureRequest:
           config(&ev.xconfigurerequest); break;
      }
   } else {
     timeval tv, tmp;
     int xfd=ConnectionNumber(disp);
     fd_set rfds;
     tmp.tv_sec=1;
     FD_ZERO(&rfds);
     FD_SET(xfd, &rfds);

     select(xfd + 1, &rfds, 0, 0, &tmp);
     gettimeofday(&tv, 0);

     for(timer *t=tim; t; t=t->next) {
       if(t && t->tv.tv_sec<=tv.tv_sec) {
         t->callback->timeout();
	 t->tv.tv_sec+=t->interval;
       }
     }

   }
  }

}



