#include "../events.h"

void events::map(XMapRequestEvent *ev) {
frame *f=d->find(ev->window);
  if(!f) f=new frame(d, ev->window, FRAME_NORMAL);
  else { XMapWindow(disp, f->win); XMapWindow(disp, f->frm); }
}

void events::unmap(XUnmapEvent *ev) {
frame *f=d->find(ev->window);
  if(f)
  if(f->unmap==0) {
    XUnmapWindow(disp, f->win);
    XUnmapWindow(disp, f->frm);
  } else f->unmap--;
}

void events::destroy(XDestroyWindowEvent *ev) {
frame *f=d->find(ev->window);
  if(f) delete f;
}

void events::expose(XExposeEvent *ev) {

}


void events::config(XConfigureRequestEvent *ev) {
XWindowChanges xwc;
frame *f=d->find(ev->window);

  if(f) {
    xwc.x=xwc.y=1;
    xwc.width=ev->width;
    xwc.height=ev->height;
    xwc.sibling=ev->above;
    xwc.stack_mode=ev->detail;
    XConfigureWindow(disp, ev->window, ev->value_mask, &xwc);

    if(ev->value_mask & CWX) f->geonorm.x=ev->x;
    if(ev->value_mask & CWY) f->geonorm.y=ev->y;
    if(ev->value_mask & CWWidth) f->geonorm.w=ev->width;
    if(ev->value_mask & CWHeight) f->geonorm.h=ev->height;
    xwc.x=f->geonorm.x-1;
    xwc.y=f->geonorm.y-1;
    xwc.width=f->geonorm.w+2;
    xwc.height=f->geonorm.h+2;
    XConfigureWindow(disp, f->frm, ev->value_mask, &xwc);
    f->setwin();
  } else {
    xwc.x=ev->x;
    xwc.y=ev->y;
    xwc.width=ev->width;
    xwc.height=ev->height;
    xwc.sibling=ev->above;
    xwc.stack_mode=ev->detail;
    XConfigureWindow(disp, ev->window, ev->value_mask, &xwc);
  }
}



