#include "../events.h"

void events::enter(XCrossingEvent *ev) {
frame *f=d->find(ev->window);
  if(f) {
    active=f;
    XSetInputFocus(disp, f->win, RevertToPointerRoot, CurrentTime);
    XGrabButton(disp, AnyButton, Mod1Mask, f->frm, False, ButtonPressMask|ButtonReleaseMask|PointerMotionMask, GrabModeAsync, GrabModeSync, None, None);
  }
}

void events::button(XEvent *ev) {
frame *f;

  if(ev->xbutton.window==*d->getroot()) {
    switch(ev->xbutton.button) {
      case Button1:
        d->reg->exec(*d->config->rootB1); break;
      case Button2:
        d->reg->exec(*d->config->rootB2); break;
      case Button3:
        d->reg->exec(*d->config->rootB3); break;
    }
  }

  switch(ev->type) {
    case ButtonPress:
      f=d->find(ev->xbutton.window);
      if(f) switch(ev->xbutton.button) {
        case Button1:
          XRaiseWindow(disp, f->frm); f->drag(ev); break;
        case Button2:
          f->resize(ev); break;
        case Button3:
          XLowerWindow(disp, f->frm); break;
      }
    break;

    case ButtonRelease:
    f=d->find(ev->xbutton.window);
      if(f && f->dragging) f->drag(ev);
      if(f && f->resizing) f->resize(ev);
    break;

    case MotionNotify:
    f=d->find(ev->xmotion.window);
      if(f && f->dragging) f->drag(ev);
      if(f && f->resizing) f->resize(ev);
    break;
  }
}
