#ifndef registry_h
#define registry_h

#include "devolution.h"

class dev; class Callback;

class registry_entry {
private:
  dev *d;
public:
  registry_entry(dev *devo, string comm);
  string command;
  registry_entry *regnext, *reglast;
};

class registry {                           
private:
  dev *d;
  Display *disp;
  registry_entry *entry;
public:
  registry(dev *devo);
  void add(string comm);
  void remove(string comm);
  void exec(string comm);
};


#endif // registry_h
