#include "splash.h"

splash::splash(dev *devo) {
XSetWindowAttributes xwa;
ImlibImage *image;
int zx, zy;

  d=devo;
  disp=d->getdisp();

  zx=(DisplayWidth(disp, d->getscreen())/2)-200;
  zy=(DisplayHeight(disp, d->getscreen())/2)-160;

  xwa.background_pixel=WhitePixel(disp, d->getscreen());
  xwa.override_redirect=True;
  xwa.event_mask = SubstructureRedirectMask|SubstructureNotifyMask|ButtonPressMask;
  win=XCreateWindow(disp, *d->getroot(), zx, zy, 400, 320, 0, CopyFromParent, InputOutput, CopyFromParent, CWOverrideRedirect|CWBackPixel|CWEventMask, &xwa);

  //d->event->addcb(this);
  t=new timer(d, this, 4);

  image=Imlib_load_image(d->dat, "/usr/share/devolution/splash.png");
  if(image) {
    XMapRaised(disp, win);
    Imlib_apply_image(d->dat, image, win);
  } else return;
}

splash::~splash() {
  XDestroyWindow(disp, win);
  d->event->remcb(this);
  delete t;
}

void splash::cb_xevent(XEvent *ev) {
  if(ev && ev->type==ButtonPress && ev->xbutton.window==win) {
    delete this;
  }
}

void splash::timeout() {
  delete this;
}
