#ifndef dev_h
#define dev_h

using namespace std;

#include <iostream>
#include <fstream>
#include <string>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xmd.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>
#include <X11/Xft/Xft.h>
#include <unistd.h>
#include <Imlib.h>
#include <stdio.h>
#include <stdlib.h>
#include "callback.h"
#include "events.h"
#include "frame.h"
#include "registry.h"
#include "conf.h"
#include "module.h"
#include "splash.h"
#include "timer.h"
#include "dlc/dlc_core/dlc_maker.h"
#include "dlc/dlc_core/dlc_maker_base.h"
#include "dlc/dlc_core/dlc_base.h"
#include "dlc/dlc_core/dlc_server.h"

class dev;
class events;
class frame;
class registry;
class conf;
class splash;


class dev {
private:
  Display *disp;
  Window  root;
  int     screen;
public:
  dev(int argc, char **argv);

  frame *head_frame;
  events *event;
  registry *reg;
  conf *config;
  splash *intro;

  frame* find(Window win);

  ImlibData *dat;

  XftFont *font;
  XftColor ffg;

  Display *getdisp() { return disp; }
  Window  *getroot() { return &root; }
  int     getscreen(){ return screen; }
  void mouse(int *x, int *y) {
    Window mouse_root, mouse_win;
    int win_x, win_y; unsigned int mask;
    XQueryPointer(disp, root, &mouse_root, &mouse_win, x, y, &win_x, &win_y, &mask);
  }
};


#endif // dev_h
